/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.onlinedaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Rückmeldungsseitiger Autark Anzeige-Inhalt eines AnzeigeQuerschnitt oder Dirigenten.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 11
 */
public class OdNichtAnzeigeAutarkIst extends AbstractOnlineDatensatz<OdNichtAnzeigeAutarkIst.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.AqZustand,
				};
			}
	
			/**
			 * Zustand durch Rückmeldung von Extern.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt AqZustand = new Aspekte("AQZustand", "asp.aqZustand");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractOnlineDatum {
		
		/**
		 * Initialisiert das Onlinedatum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.WvzInhalt
				 _anzeigeInhalt
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
				 _kommunikationsausfall
				;
		
			/**
			Referenz auf WVZInhalt.
			<p>
			
			</p>
			
			@return der Wert von AnzeigeInhalt.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.WvzInhalt
				 getAnzeigeInhalt() {
				return _anzeigeInhalt;
			}
		
			/**
			Referenz auf WVZInhalt.
			<p>
			
			</p>
			
			@param _anzeigeInhalt der neue Wert von AnzeigeInhalt.
			*/
			public void setAnzeigeInhalt(	de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.WvzInhalt
			 _anzeigeInhalt) {
				this._anzeigeInhalt = _anzeigeInhalt;
			}
		
			/**
			Kommunikationsausfall zu AnzeigeQuerschnitt oder Dirigent.
			<p>
			
			</p>
			
			@return der Wert von Kommunikationsausfall.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
				 getKommunikationsausfall() {
				return _kommunikationsausfall;
			}
		
			/**
			Kommunikationsausfall zu AnzeigeQuerschnitt oder Dirigent.
			<p>
			
			</p>
			
			@param _kommunikationsausfall der neue Wert von Kommunikationsausfall.
			*/
			public void setKommunikationsausfall(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
			 _kommunikationsausfall) {
				this._kommunikationsausfall = _kommunikationsausfall;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final Object soAnzeigeInhalt = getAnzeigeInhalt();
						final SystemObject tmpAnzeigeInhalt;
							if (soAnzeigeInhalt instanceof SystemObject) {
								tmpAnzeigeInhalt = (SystemObject)soAnzeigeInhalt;
							} else if(soAnzeigeInhalt instanceof SystemObjekt){
								tmpAnzeigeInhalt = ((SystemObjekt)soAnzeigeInhalt).getSystemObject();
							} else{
								tmpAnzeigeInhalt = null;
							}
						datum.getReferenceValue("AnzeigeInhalt").setSystemObject(tmpAnzeigeInhalt);
					// GanzzahlAttributTyp
					if (getKommunikationsausfall() != null) {
		                if (getKommunikationsausfall().isZustand()) {
		                    datum.getUnscaledValue("Kommunikationsausfall").setText(getKommunikationsausfall().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("Kommunikationsausfall").set(getKommunikationsausfall().getValue());
		                }
					}
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final long idAnzeigeInhalt = daten.getReferenceValue("AnzeigeInhalt").getId();
						final SystemObjekt tmpAnzeigeInhalt;
						if (idAnzeigeInhalt == 0) {
							tmpAnzeigeInhalt = null;
						} else {
							final SystemObject soAnzeigeInhalt = factory.getDav().getDataModel().getObject(idAnzeigeInhalt);
							if (soAnzeigeInhalt == null) {
									tmpAnzeigeInhalt = new de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.impl.WvzInhaltUngueltig(idAnzeigeInhalt);
							} else {
								tmpAnzeigeInhalt = factory.getModellobjekt(soAnzeigeInhalt);
							}
						}
						setAnzeigeInhalt((	de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.WvzInhalt
						) tmpAnzeigeInhalt);
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("Kommunikationsausfall").isState()) {
								setKommunikationsausfall(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
								.getZustand(daten.getScaledValue("Kommunikationsausfall").getText()));
							} else {
							setKommunikationsausfall(new de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
							(daten.
								getUnscaledValue
							("Kommunikationsausfall").
									byteValue
							()));
							}
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setAnzeigeInhalt(getAnzeigeInhalt());
							klon.setKommunikationsausfall(getKommunikationsausfall());
			
			
			klon.dSetZeitstempel(dGetZeitstempel());
			klon.dSetDatenStatus(dGetDatenStatus());
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}

		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.nichtAnzeigeAutarkIst";

	/**
	 * Initialisiert den Onlinedatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public OdNichtAnzeigeAutarkIst(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
