/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.objekte.impl;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
repräsentiert ein Event mit einer Bewertung des Windes in
					Sektoren.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 2
 */
public class VbaEventUfdWindSektorImpl extends AbstractSystemObjekt
	implements de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.objekte.VbaEventUfdWindSektor { 

	/**
	 * Der Defaultkonstruktor wird für das Erzeugen des Systemobjekts über per
	 * Reflection-API benötigt.
	 */
	public VbaEventUfdWindSektorImpl() {
		// tut nix
	}
	
	/**
	 * Initialisierung.
	 * 
	 * @param objekt
	 *            ein beliebiges Systemobjekt.
	 * @param factory
	 *            die Fabrik, die das Systemobjekt angelegt hat.
	 */
	public VbaEventUfdWindSektorImpl(final SystemObject objekt, final ObjektFactory factory) {
		super(objekt, factory);
		
		if (!objekt.isOfType(getTyp().getPid())) {
			throw new IllegalArgumentException(
					"Systemobjekt ist kein VBA Event WindSektoren.");
		}
	}
	
	@Override
	protected String doGetTypPid() {
		return PID;
	}
	
	/*
	 * Beginn Abschnitt Mengen
	 */
	

	/*
	 * Ende Abschnitt Mengen
	 */

	/*
	 * Beginn Abschnitt Attributgruppen
	 */

	public de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventUfdWindsektoren getPdVbaEventUfdWindsektoren() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventUfdWindsektoren.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.bitctrlbasic.parameter.PdFlexiblesObjektParameter getPdFlexiblesObjektParameter() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.bitctrlbasic.parameter.PdFlexiblesObjektParameter.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.onlinedaten.OdVbaEventZustand getOdVbaEventZustand() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.onlinedaten.OdVbaEventZustand.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdDefaultParameterdatensaetze getKdDefaultParameterdatensaetze() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdDefaultParameterdatensaetze.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventParameterUfdsTypen getPdVbaEventParameterUfdsTypen() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventParameterUfdsTypen.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventParameter getPdVbaEventParameter() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventParameter.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdInfo getKdInfo() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdInfo.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.konfigurationsdaten.KdVbaEventUmfeld getKdVbaEventUmfeld() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.konfigurationsdaten.KdVbaEventUmfeld.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.konfigurationsdaten.KdVbaEventEigenschaften getKdVbaEventEigenschaften() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.konfigurationsdaten.KdVbaEventEigenschaften.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.bitctrlbasic.onlinedaten.OdFlexiblesObjektOnline getOdFlexiblesObjektOnline() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.bitctrlbasic.onlinedaten.OdFlexiblesObjektOnline.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdAlternativeObjektbezeichnung getKdAlternativeObjektbezeichnung() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdAlternativeObjektbezeichnung.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventKlassenParameter getPdVbaEventKlassenParameter() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlevent.parameter.PdVbaEventKlassenParameter.class);
	}
	
	
	/*
	 * Ende Abschnitt Attributgruppen
	 */
	
	// Sonderfall Klasse AttributImpl
	 

}
