/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.konfigurationsdaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Daten eines konkreten Geräts.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 2
 */
public class KdGeraet extends AbstractKonfigurationsDatensatz<KdGeraet.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.Eigenschaften,
				};
			}
	
			/**
			 * Wird für konfigurierende Attributgruppen verwendet. Über die entsprechende Attributgruppe werden die konkreten Eigenschaften eines Objekts festgelegt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt Eigenschaften = new Aspekte("Eigenschaften", "asp.eigenschaften");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractDatum implements KonfigurationsDatum {
		
		/**
		 * Initialisiert das Datum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.GeraeteTyp
				 _zuGeraeteTyp
				;
				private Feld<String
				> _bezeichnung = new Feld<String
				>(0, true);
				private Feld<	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.Geraet
				> _komponenten = new Feld<	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.Geraet
				>(0, true);
		
			/**
			Referenz auf den Typ, von dem dieses konkrete Gerät ist.
			<p>
			
			</p>
			
			@return der Wert von ZuGeraeteTyp.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.GeraeteTyp
				 getZuGeraeteTyp() {
				return _zuGeraeteTyp;
			}
		
			/**
			Referenz auf den Typ, von dem dieses konkrete Gerät ist.
			<p>
			
			</p>
			
			@param _zuGeraeteTyp der neue Wert von ZuGeraeteTyp.
			*/
			public void setZuGeraeteTyp(	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.GeraeteTyp
			 _zuGeraeteTyp) {
				this._zuGeraeteTyp = _zuGeraeteTyp;
			}
		
			/**
			Bezeichnung dieses konkreten Geräts (Freitext).
			<p>
			
			</p>
			
			@return der Wert von Bezeichnung.
			*/
				public Feld<String
				> getBezeichnung() {
				return _bezeichnung;
			}
		
		
			/**
			Referenz weitere Geraete, die Komponenten dieses Geraets sind.
			<p>
			
			</p>
			
			@return der Wert von Komponenten.
			*/
				public Feld<	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.Geraet
				> getKomponenten() {
				return _komponenten;
			}
		
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final Object soZuGeraeteTyp = getZuGeraeteTyp();
						final SystemObject tmpZuGeraeteTyp;
							if (soZuGeraeteTyp instanceof SystemObject) {
								tmpZuGeraeteTyp = (SystemObject)soZuGeraeteTyp;
							} else if(soZuGeraeteTyp instanceof SystemObjekt){
								tmpZuGeraeteTyp = ((SystemObjekt)soZuGeraeteTyp).getSystemObject();
							} else{
								tmpZuGeraeteTyp = null;
							}
						datum.getReferenceValue("ZuGeraeteTyp").setSystemObject(tmpZuGeraeteTyp);
					// ZeichenkettenAttributTyp
					if (getBezeichnung() != null) {
						final Data.TextArray arrayBezeichnung = datum.getTextArray("Bezeichnung");
						arrayBezeichnung.setLength(getBezeichnung().size());
						for (int i = 0; i < arrayBezeichnung.getLength(); ++i) {
							arrayBezeichnung.getTextValue(i).setText(getBezeichnung().get(i));
						}
					}
					// ObjektReferenzAttributTyp
						final Data.ReferenceArray arrayKomponenten = datum.getReferenceArray("Komponenten");
						arrayKomponenten.setLength(getKomponenten().size());
						for (int i = 0; i < arrayKomponenten.getLength(); ++i) {
							final Object soKomponenten = getKomponenten().get(i);
							final SystemObject tmpKomponenten;
							if (soKomponenten instanceof SystemObject) {
								tmpKomponenten = (SystemObject)soKomponenten;
							} else if(soKomponenten instanceof SystemObjekt){
								tmpKomponenten = ((SystemObjekt)soKomponenten).getSystemObject();
							} else{
								tmpKomponenten = null;
							}
							arrayKomponenten.getReferenceValue(i).setSystemObject(tmpKomponenten);
						}
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final long idZuGeraeteTyp = daten.getReferenceValue("ZuGeraeteTyp").getId();
						final SystemObjekt tmpZuGeraeteTyp;
						if (idZuGeraeteTyp == 0) {
							tmpZuGeraeteTyp = null;
						} else {
							final SystemObject soZuGeraeteTyp = factory.getDav().getDataModel().getObject(idZuGeraeteTyp);
							if (soZuGeraeteTyp == null) {
									tmpZuGeraeteTyp = new de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.impl.GeraeteTypUngueltig(idZuGeraeteTyp);
							} else {
								tmpZuGeraeteTyp = factory.getModellobjekt(soZuGeraeteTyp);
							}
						}
						setZuGeraeteTyp((	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.GeraeteTyp
						) tmpZuGeraeteTyp);
					// ZeichenkettenAttributTyp
						final Data.TextArray arrayBezeichnung = daten.getTextArray("Bezeichnung");
						for (int i = 0; i < arrayBezeichnung.getLength(); ++i) {
							getBezeichnung().add(arrayBezeichnung.getText(i));
						}
					// ObjektReferenzAttributTyp
						final Data.ReferenceArray arrayKomponenten = daten.getReferenceArray("Komponenten");
						for (int i = 0; i < arrayKomponenten.getLength(); ++i) {
							final long idKomponenten = daten.getReferenceArray("Komponenten").getReferenceValue(i).getId();
							final SystemObjekt tmpKomponenten;
							if (idKomponenten == 0) {
								tmpKomponenten = null;
							} else {
								final SystemObject soKomponenten = factory.getDav().getDataModel().getObject(idKomponenten);
								if (soKomponenten == null) {
										tmpKomponenten = new de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.impl.GeraetUngueltig(idKomponenten);
								} else {
									tmpKomponenten = factory.getModellobjekt(soKomponenten);
								}
							}
								getKomponenten().add((	de.bsvrz.sys.funclib.bitctrl.modell.tmgeraeteeinbauorte.objekte.Geraet
								) tmpKomponenten);
						}
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setZuGeraeteTyp(getZuGeraeteTyp());
						klon._bezeichnung = getBezeichnung().clone();
						klon._komponenten = getKomponenten().clone();
			
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}
	
		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.geraet";

	/**
	 * Initialisiert den Konfigurationsdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public KdGeraet(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
