/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.konfigurationsdaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Konfigurierende Eigenschaften der Objekte des Typs.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 3
 */
public class KdTmcLinie extends AbstractKonfigurationsDatensatz<KdTmcLinie.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.Eigenschaften,
				};
			}
	
			/**
			 * Wird für konfigurierende Attributgruppen verwendet. Über die entsprechende Attributgruppe werden die konkreten Eigenschaften eines Objekts festgelegt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt Eigenschaften = new Aspekte("Eigenschaften", "asp.eigenschaften");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractDatum implements KonfigurationsDatum {
		
		/**
		 * Initialisiert das Datum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
				 _vorgaenger
				;
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
				 _nachfolger
				;
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
				 _istTeilvonTmcLinie
				;
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcGebiet
				 _istTeilvonTmcGebiet
				;
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcLinie (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@return der Wert von Vorgaenger.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
				 getVorgaenger() {
				return _vorgaenger;
			}
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcLinie (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@param _vorgaenger der neue Wert von Vorgaenger.
			*/
			public void setVorgaenger(	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
			 _vorgaenger) {
				this._vorgaenger = _vorgaenger;
			}
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcLinie (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@return der Wert von Nachfolger.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
				 getNachfolger() {
				return _nachfolger;
			}
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcLinie (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@param _nachfolger der neue Wert von Nachfolger.
			*/
			public void setNachfolger(	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
			 _nachfolger) {
				this._nachfolger = _nachfolger;
			}
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcLinie (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@return der Wert von IstTeilvonTmcLinie.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
				 getIstTeilvonTmcLinie() {
				return _istTeilvonTmcLinie;
			}
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcLinie (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@param _istTeilvonTmcLinie der neue Wert von IstTeilvonTmcLinie.
			*/
			public void setIstTeilvonTmcLinie(	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
			 _istTeilvonTmcLinie) {
				this._istTeilvonTmcLinie = _istTeilvonTmcLinie;
			}
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcGebiet (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@return der Wert von IstTeilvonTmcGebiet.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcGebiet
				 getIstTeilvonTmcGebiet() {
				return _istTeilvonTmcGebiet;
			}
		
			/**
			Attribut zur Referenzierung des Objekttyps: typ.tmcGebiet (Optionale Referenzierung erlaubt).
			<p>
			
			</p>
			
			@param _istTeilvonTmcGebiet der neue Wert von IstTeilvonTmcGebiet.
			*/
			public void setIstTeilvonTmcGebiet(	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcGebiet
			 _istTeilvonTmcGebiet) {
				this._istTeilvonTmcGebiet = _istTeilvonTmcGebiet;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final Object soVorgaenger = getVorgaenger();
						final SystemObject tmpVorgaenger;
							if (soVorgaenger instanceof SystemObject) {
								tmpVorgaenger = (SystemObject)soVorgaenger;
							} else if(soVorgaenger instanceof SystemObjekt){
								tmpVorgaenger = ((SystemObjekt)soVorgaenger).getSystemObject();
							} else{
								tmpVorgaenger = null;
							}
						datum.getReferenceValue("Vorgänger").setSystemObject(tmpVorgaenger);
					// ObjektReferenzAttributTyp
						final Object soNachfolger = getNachfolger();
						final SystemObject tmpNachfolger;
							if (soNachfolger instanceof SystemObject) {
								tmpNachfolger = (SystemObject)soNachfolger;
							} else if(soNachfolger instanceof SystemObjekt){
								tmpNachfolger = ((SystemObjekt)soNachfolger).getSystemObject();
							} else{
								tmpNachfolger = null;
							}
						datum.getReferenceValue("Nachfolger").setSystemObject(tmpNachfolger);
					// ObjektReferenzAttributTyp
						final Object soIstTeilvonTmcLinie = getIstTeilvonTmcLinie();
						final SystemObject tmpIstTeilvonTmcLinie;
							if (soIstTeilvonTmcLinie instanceof SystemObject) {
								tmpIstTeilvonTmcLinie = (SystemObject)soIstTeilvonTmcLinie;
							} else if(soIstTeilvonTmcLinie instanceof SystemObjekt){
								tmpIstTeilvonTmcLinie = ((SystemObjekt)soIstTeilvonTmcLinie).getSystemObject();
							} else{
								tmpIstTeilvonTmcLinie = null;
							}
						datum.getReferenceValue("istTeilvonTmcLinie").setSystemObject(tmpIstTeilvonTmcLinie);
					// ObjektReferenzAttributTyp
						final Object soIstTeilvonTmcGebiet = getIstTeilvonTmcGebiet();
						final SystemObject tmpIstTeilvonTmcGebiet;
							if (soIstTeilvonTmcGebiet instanceof SystemObject) {
								tmpIstTeilvonTmcGebiet = (SystemObject)soIstTeilvonTmcGebiet;
							} else if(soIstTeilvonTmcGebiet instanceof SystemObjekt){
								tmpIstTeilvonTmcGebiet = ((SystemObjekt)soIstTeilvonTmcGebiet).getSystemObject();
							} else{
								tmpIstTeilvonTmcGebiet = null;
							}
						datum.getReferenceValue("istTeilvonTmcGebiet").setSystemObject(tmpIstTeilvonTmcGebiet);
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final long idVorgaenger = daten.getReferenceValue("Vorgänger").getId();
						final SystemObjekt tmpVorgaenger;
						if (idVorgaenger == 0) {
							tmpVorgaenger = null;
						} else {
							final SystemObject soVorgaenger = factory.getDav().getDataModel().getObject(idVorgaenger);
							if (soVorgaenger == null) {
									tmpVorgaenger = new de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.impl.TmcLinieUngueltig(idVorgaenger);
							} else {
								tmpVorgaenger = factory.getModellobjekt(soVorgaenger);
							}
						}
						setVorgaenger((	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
						) tmpVorgaenger);
					// ObjektReferenzAttributTyp
						final long idNachfolger = daten.getReferenceValue("Nachfolger").getId();
						final SystemObjekt tmpNachfolger;
						if (idNachfolger == 0) {
							tmpNachfolger = null;
						} else {
							final SystemObject soNachfolger = factory.getDav().getDataModel().getObject(idNachfolger);
							if (soNachfolger == null) {
									tmpNachfolger = new de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.impl.TmcLinieUngueltig(idNachfolger);
							} else {
								tmpNachfolger = factory.getModellobjekt(soNachfolger);
							}
						}
						setNachfolger((	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
						) tmpNachfolger);
					// ObjektReferenzAttributTyp
						final long idIstTeilvonTmcLinie = daten.getReferenceValue("istTeilvonTmcLinie").getId();
						final SystemObjekt tmpIstTeilvonTmcLinie;
						if (idIstTeilvonTmcLinie == 0) {
							tmpIstTeilvonTmcLinie = null;
						} else {
							final SystemObject soIstTeilvonTmcLinie = factory.getDav().getDataModel().getObject(idIstTeilvonTmcLinie);
							if (soIstTeilvonTmcLinie == null) {
									tmpIstTeilvonTmcLinie = new de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.impl.TmcLinieUngueltig(idIstTeilvonTmcLinie);
							} else {
								tmpIstTeilvonTmcLinie = factory.getModellobjekt(soIstTeilvonTmcLinie);
							}
						}
						setIstTeilvonTmcLinie((	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcLinie
						) tmpIstTeilvonTmcLinie);
					// ObjektReferenzAttributTyp
						final long idIstTeilvonTmcGebiet = daten.getReferenceValue("istTeilvonTmcGebiet").getId();
						final SystemObjekt tmpIstTeilvonTmcGebiet;
						if (idIstTeilvonTmcGebiet == 0) {
							tmpIstTeilvonTmcGebiet = null;
						} else {
							final SystemObject soIstTeilvonTmcGebiet = factory.getDav().getDataModel().getObject(idIstTeilvonTmcGebiet);
							if (soIstTeilvonTmcGebiet == null) {
									tmpIstTeilvonTmcGebiet = new de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.impl.TmcGebietUngueltig(idIstTeilvonTmcGebiet);
							} else {
								tmpIstTeilvonTmcGebiet = factory.getModellobjekt(soIstTeilvonTmcGebiet);
							}
						}
						setIstTeilvonTmcGebiet((	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcGebiet
						) tmpIstTeilvonTmcGebiet);
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setVorgaenger(getVorgaenger());
							klon.setNachfolger(getNachfolger());
							klon.setIstTeilvonTmcLinie(getIstTeilvonTmcLinie());
							klon.setIstTeilvonTmcGebiet(getIstTeilvonTmcGebiet());
			
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}
	
		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.tmcLinie";

	/**
	 * Initialisiert den Konfigurationsdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public KdTmcLinie(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
