/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.konfigurationsdaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Konfigurierende Eigenschaften der Objekte des Typs. Enthält ZUSÄTZLICHE Informationen der LCL zu
					diesem Objekt.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 53
 */
public class KdStrassenKnotenLclInfo extends AbstractKonfigurationsDatensatz<KdStrassenKnotenLclInfo.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.Eigenschaften,
				};
			}
	
			/**
			 * Wird für konfigurierende Attributgruppen verwendet. Über die entsprechende Attributgruppe werden die konkreten Eigenschaften eines Objekts festgelegt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt Eigenschaften = new Aspekte("Eigenschaften", "asp.eigenschaften");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractDatum implements KonfigurationsDatum {
		
		/**
		 * Initialisiert das Datum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private Feld<	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcPunkt
				> _tmcPunkt = new Feld<	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcPunkt
				>(0, true);
		
			/**
			TMCPunkt(e), die diesem Knoten zugeordneten sind.
			<p>
			
			</p>
			
			@return der Wert von TmcPunkt.
			*/
				public Feld<	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcPunkt
				> getTmcPunkt() {
				return _tmcPunkt;
			}
		
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final Data.ReferenceArray arrayTmcPunkt = datum.getReferenceArray("TmcPunkt");
						arrayTmcPunkt.setLength(getTmcPunkt().size());
						for (int i = 0; i < arrayTmcPunkt.getLength(); ++i) {
							final Object soTmcPunkt = getTmcPunkt().get(i);
							final SystemObject tmpTmcPunkt;
							if (soTmcPunkt instanceof SystemObject) {
								tmpTmcPunkt = (SystemObject)soTmcPunkt;
							} else if(soTmcPunkt instanceof SystemObjekt){
								tmpTmcPunkt = ((SystemObjekt)soTmcPunkt).getSystemObject();
							} else{
								tmpTmcPunkt = null;
							}
							arrayTmcPunkt.getReferenceValue(i).setSystemObject(tmpTmcPunkt);
						}
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final Data.ReferenceArray arrayTmcPunkt = daten.getReferenceArray("TmcPunkt");
						for (int i = 0; i < arrayTmcPunkt.getLength(); ++i) {
							final long idTmcPunkt = daten.getReferenceArray("TmcPunkt").getReferenceValue(i).getId();
							final SystemObjekt tmpTmcPunkt;
							if (idTmcPunkt == 0) {
								tmpTmcPunkt = null;
							} else {
								final SystemObject soTmcPunkt = factory.getDav().getDataModel().getObject(idTmcPunkt);
								if (soTmcPunkt == null) {
										tmpTmcPunkt = new de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.impl.TmcPunktUngueltig(idTmcPunkt);
								} else {
									tmpTmcPunkt = factory.getModellobjekt(soTmcPunkt);
								}
							}
								getTmcPunkt().add((	de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.objekte.TmcPunkt
								) tmpTmcPunkt);
						}
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
						klon._tmcPunkt = getTmcPunkt().clone();
			
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}
	
		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.straßenKnotenLclInfo";

	/**
	 * Initialisiert den Konfigurationsdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public KdStrassenKnotenLclInfo(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
