/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmkexlmstglobal.attribute;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Geografische GeographischeRelevanz der Meldung.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 1
 */
public class AttRdsGeographischeRelevanz extends Zahl<		Byte
> {
	
	private static final long serialVersionUID = 1L;
	
	
	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_0_LOKAL = new AttRdsGeographischeRelevanz("Lokal", 		Byte
	.valueOf("0"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_1_REGIONAL = new AttRdsGeographischeRelevanz("Regional", 		Byte
	.valueOf("1"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_2_UEBERREGIONAL = new AttRdsGeographischeRelevanz("Überregional", 		Byte
	.valueOf("2"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_3_NATIONAL = new AttRdsGeographischeRelevanz("National", 		Byte
	.valueOf("3"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_4_AUSLAND = new AttRdsGeographischeRelevanz("Ausland", 		Byte
	.valueOf("4"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_5_LOKAL_UND_ANGRENZENDES_AUSLAND = new AttRdsGeographischeRelevanz("Lokal und angrenzendes Ausland", 		Byte
	.valueOf("5"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_6_REGIONAL_UND_ANGRENZENDES_AUSLAND = new AttRdsGeographischeRelevanz("Regional und angrenzendes Ausland", 		Byte
	.valueOf("6"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_7_UEBERREGIONAL_UND_ANGRENZENDES_AUSLAND = new AttRdsGeographischeRelevanz("Überregional und angrenzendes Ausland", 		Byte
	.valueOf("7"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttRdsGeographischeRelevanz ZUSTAND_8_LAND_UND_ANGRENZENDES_AUSLAND = new AttRdsGeographischeRelevanz("Land und angrenzendes Ausland", 		Byte
	.valueOf("8"));

	/**
	 * Gibt den Zustand zu einer Zahl zurück oder <code>null</code>, wenn die
	 * Zahl keinen Zustand repräsentiert.
	 *
	 * @param value ein Zahlenwert
	 * @return der Zustand zu dem Zahlenwert oder <code>null</code>, wenn die
	 * Zahl keine Entsprechnung als Zustand besitzt.
	 */
	public static AttRdsGeographischeRelevanz getZustand(final 		Byte
	 value) {
		for (AttRdsGeographischeRelevanz e : getZustaende()) {
			if (e.getValue().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt den Zustand zu einem Zustandsnamen zurück oder <code>null</code>,
	 * wenn kein Zustand einen solchen Namen hat.
	 * 
	 * @param value
	 *            der Zustandsname
	 * @return der Zustand zu dem Zustandsnamen oder <code>null</code>, wenn
	 *         kein Zustand einen solchen Namen hat.
	 */
	public static AttRdsGeographischeRelevanz getZustand(final String value) {
		for (AttRdsGeographischeRelevanz e : getZustaende()) {
			if (e.toString().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt alle Zustände zurück, die das Attribut besitzen kann.
	 *
	 * @return alle Zustände die das Attribut annehmen kann.
	 */
	public static List<AttRdsGeographischeRelevanz> getZustaende() {
		List<AttRdsGeographischeRelevanz> list = new ArrayList<AttRdsGeographischeRelevanz>();
		list.add(ZUSTAND_0_LOKAL);
		list.add(ZUSTAND_1_REGIONAL);
		list.add(ZUSTAND_2_UEBERREGIONAL);
		list.add(ZUSTAND_3_NATIONAL);
		list.add(ZUSTAND_4_AUSLAND);
		list.add(ZUSTAND_5_LOKAL_UND_ANGRENZENDES_AUSLAND);
		list.add(ZUSTAND_6_REGIONAL_UND_ANGRENZENDES_AUSLAND);
		list.add(ZUSTAND_7_UEBERREGIONAL_UND_ANGRENZENDES_AUSLAND);
		list.add(ZUSTAND_8_LAND_UND_ANGRENZENDES_AUSLAND);
		return list;
	}	
	/**
	 * Erzeugte eine neues Attribut .
	 *
	 * @param value der Wert der Zahl.
	 */
	public AttRdsGeographischeRelevanz(final 		Byte
	 value) {
		super(value);
	}
	
	private AttRdsGeographischeRelevanz(final String zustand, final 		Byte
	 value) {
		super(zustand, value);
	}
	
}
